<?php

	class csvExporter extends umiExporter {
		public function setOutputBuffer() {
			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$buffer->charset("windows-1251");
			$buffer->contentType("text/plain");
			return $buffer;
		}

		public function export($branches) {
			if (!count($branches)) {
				$sel = new selector('pages');
				$sel->where('hierarchy')->page(0)->childs(0);
				$branches = $sel->result;
			}

			$temp_dir = CURRENT_WORKING_DIR . "/sys-temp/export/";
			$id = getRequest('param0');
			if (!is_dir($temp_dir)) mkdir($temp_dir, 0777, true);
			$cache_file_path = $temp_dir . $id . "." . $this->getFileExt();

			$sourceName = $id . "." . $this->getFileExt();

			$exporter = new xmlExporter($sourceName);
			$exporter->addBranches($branches);
			$exporter->setIgnoreRelations();

			$doc = $exporter->execute();
			$list = $this->getCSV($doc);

			$handle = fopen($cache_file_path, 'w');
			foreach ($list as $fields) {
				$fields = "\"" . implode('";"', $fields) . "\"\n";
			    fputs($handle, $fields);
			}
			fclose($handle);

			chmod($cache_file_path, 0777);

			return iconv('utf-8', 'windows-1251', file_get_contents($cache_file_path));
		}

		public function getFileExt() {
			return "csv";
		}

		protected function getCSV($doc) {

			$result = array();

			$names = array(
				0 => 'id',
				1 => 'name',
				2 => 'type-id',
				3 => 'is-active',
				4 => 'template-id',
				5 => 'parent-id'
			);

			$titles = array(
				0 => 'id',
				1 => 'Наименование',
				2 => 'Идентификатор типа',
				3 => 'Активность',
				4 => 'Идентификатор шаблона',
				5 => 'id родительской страницы'
			);

			$types = array(
				0 => 'native',
				1 => 'native',
				2 => 'native',
				3 => 'native',
				4 => 'native',
				5 => 'native'
			);

			$xpath = new DOMXPath($doc);

			if ($xpath->query('//pages/page')->length) {

				$pages = $xpath->query('//pages/page');
				$i = 3;
				foreach ($pages as $page) {
					$pageContent = array();
					$pageContent[0] = $page->getAttribute('id');
					$pageContent[1] = $page->getElementsByTagName('name')->item(0)->nodeValue;
					$pageContent[2] = $page->getAttribute('type-id');
					$pageContent[3] = $page->getAttribute('is-active');
					if ($page->getElementsByTagName('template')->length) {
						$pageContent[4] = $page->getElementsByTagName('template')->item(0)->getAttribute('id');
					} else {
						$pageContent[4]='';
					}

					$pageContent[5] = $page->hasAttribute('parentId') ? $page->getAttribute('parentId') : 0;
					$properties = $page->getElementsByTagName('property');

					foreach ($properties as $property) {

						$propName = $property->getAttribute('name');
						$propType = $property->getAttribute('type');

						if(in_array($propType, array('optioned', 'symlink', 'relation'))) continue;

						$key = array_search($propName, $names);

						if (!$key) {
							$names[] = $propName;
							$key = array_search($propName, $names);
							$types[$key] = $propType;
							$propTitle = $property->getElementsByTagName('title')->item(0)->nodeValue;
							$titles[$key] = $propTitle;
						}

						$propValue = $property->getElementsByTagName('value')->item(0)->nodeValue;
						$pageContent[$key] = $propValue;
					}

					$keys = array_keys($names);
					foreach ($keys as $key) {
						if (!array_key_exists($key, $pageContent)) {
							$pageContent[$key] ='';
						} else {
							$pageContent[$key] = str_replace('"', '""', $pageContent[$key]);
						}
					}

					ksort($pageContent);
					$result[$i] = $pageContent;
					$i++;
				}
			}

			$result[0] = $names;
			$result[1] = $titles;
			$result[2] = $types;
			ksort($result);

			return $result;
		}

	}
?>