<?php

	class YMLExporter extends umiExporter {
		public function setOutputBuffer() {
			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$buffer->charset("windows-1251");
			$buffer->contentType("text/xml");
			return $buffer;
		}

		public function export($branches) {

			$id = getRequest('param0');
			$dirName = CURRENT_WORKING_DIR . "/sys-temp/yml/";

			if(!file_exists($dirName . $id . 'el')) {
				throw new publicException('<a href="' . getLabel("label-errors-no-information") . '" target="blank">' . getLabel("label-errors-no-information") .'</a>');
			}

			$elementsToExport = unserialize(file_get_contents($dirName . $id . 'el'));
			$dir = dir($dirName);
			$xml = $dirName . $id . ".xml";
			if(file_exists($xml)) unlink ($xml);

			file_put_contents($xml, '<?xml version="1.0" encoding="windows-1251"?><yml_catalog date="' . date('Y-m-d H:i') . '"><shop>', FILE_APPEND);
			if(file_exists($dirName . 'shop' . $id)) file_put_contents($xml, file_get_contents($dirName . 'shop' . $id), FILE_APPEND);

			if (file_exists($dirName . 'currencies')) file_put_contents($xml, file_get_contents($dirName . 'currencies'), FILE_APPEND);

			if (file_exists($dirName . 'categories')) {
				file_put_contents($xml, '<categories>', FILE_APPEND);
				$categories = unserialize(file_get_contents($dirName . 'categories'));
				foreach ($categories as $categoryId => $name) {
					$name = iconv("UTF-8", "CP1251", $name);
					file_put_contents($xml, '<category id="' . $categoryId . '">' . $name . '</category>', FILE_APPEND);
				}
				file_put_contents($xml, '</categories>', FILE_APPEND);
			}

			file_put_contents($xml, '<offers>', FILE_APPEND);

			while (false !== ($file = $dir->read())) {
				if(is_file($dirName . $file) && in_array(trim($file, '.txt'), $elementsToExport)) {
					file_put_contents($xml, file_get_contents($dirName . $file), FILE_APPEND);
				}
			}
			$dir->close();
			file_put_contents($xml, '</offers></shop></yml_catalog>', FILE_APPEND);
			return file_get_contents($xml);

		}

	}
?>