<?php

	class socialVkontakteExporter extends umiExporter {
		public function setOutputBuffer() {
			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$buffer->charset("utf-8");
			$buffer->contentType("text/html");
			return $buffer;
		}

		public function export($branches) {


			
			$this->prepareObjects($branches);
			if(empty($this->elements)) {
				throw new publicException("No items to export");
			}
			
			$regedit = regedit::getInstance();
			$merchant_id = (string) $regedit->getVal('//modules/emarket/social_vkontakte_merchant_id');
			$secret = $regedit->getVal('//modules/emarket/social_vkontakte_key');

			
			if( !$merchant_id) { /// todo
				throw new publicException(getLabel('error-social-config'));;
			}
			
			
			$sel = new selector('objects');
			//socialTODO
			$sel->types('object-type')->id(  umiObjectTypesCollection::getInstance()->getTypeIdByGUID('social_categories_vkontakte') ); 
			$result = $sel->result(	);
			
			$social_categories = array();
			foreach($result as $v)
			{
				$social_categories[ $v->getId() ] = $v->getValue("social_id") ;;
			}
			
			$c = 0;
			$request_url = 'http://api.vkontakte.ru/merchant.php';
			$_elements = $this->elements;
			
			$Hierarchy = umiHierarchy::getInstance();
			while(true) {
				
				$elements = array_splice($_elements, 0, 1000);
				
				if(empty($elements)) {
					break;
				}
				
				$params = array(
				  'merchant_id' => $merchant_id,
				  'timestamp'   => time(),
				  'test_mode'   => $regedit->getVal('//modules/emarket/social_vkontakte_testmode'),
				  'method'      => 'catalog.changeItems',
				  'random'      => mt_rand(0, 1000000)
				);

				$i=1;
				foreach($elements as $elementId) {
					$element = $Hierarchy->getElement((int) $elementId->getId(), false, false);
					if(!$element instanceof umiHierarchyElement ) {
					    continue;
					}	
					
					$dsc = $element->getValue('description')
					;
					if(empty($dsc)) {
						$dsc = getLabel('error-social-nodsc');
					}
					$dsc = templater::getInstance()->parseInput(str_replace('&#037;', '%', $dsc));

					$category = $Hierarchy->getElement($element->getRel(), false, false);
					
					$element_social_category = $category->getObject()->getValue("social_category_vkontakte") ;
					
					
					if(!isset($social_categories[$element_social_category])) {
						$element_social_category  = 1;
					}
					else {
						$element_social_category  = $social_categories[$element_social_category];
					}

					$params['item_id_'.$i] = (string) $element->getId();
					$params['item_name_'.$i] = (string) $element->getName();
					$params['item_description_'.$i] = (string) $dsc;
					$params['item_currency_'.$i] = 'RUB';
					$params['item_price_'.$i] = (string) $element->getValue('price');
					$params['item_photo_url_'.$i.'_1'] = (string) getServer('HTTP_HOST').$element->getValue('photo');
					$params['item_category_'.$i] = $element_social_category;
					$params['item_unavailable_'.$i] = (string)  !$element->getIsActive();
					$params['item_digital_'.$i] =  (string) $element->getValue('is_digital');;
					$params['item_tags_'.$i] = implode ( ', ', $element->getValue('tags'));
					
					 $i++;
				}
			
				$c += ($i-1);
			
				ksort($params);
				$params_sig = '';
				$params_pairs = array();
				foreach ($params as $k => $v) {
				  $params_sig .= $k.'='.$v;
				  $params_pairs[] = $k.'='.urlencode($v);
				}
				$params_sig .= $secret;
				$params_pairs[] = 'sig='.md5($params_sig);
				$params_str = implode('&', $params_pairs);

				$rc = 0;
				


				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, $request_url);
				curl_setopt($ch, CURLOPT_FAILONERROR, 1);
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_TIMEOUT, 15);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params_str);

				$result = curl_exec($ch);
				$rc = curl_errno($ch);
				
				if ($rc) {
					//return  (getLabel('error-social-export'));
					throw new publicException(getLabel('error-social-export'));;
				}
				
				curl_close($ch);
				
				if(strpos($result, 'error') !== false) {
					preg_match('/<error_code>(.*)<\/error_code>/iu', $result, $match);
					$code = isset($match[1]) ? $match[1]:"";
					
					preg_match('/<error_msg>(.*)<\/error_msg>/iu', $result, $match);
					$msg = isset($match[1]) ? $match[1]:"";
					
					return  (getLabel('error-social-export') . " (" . $code .": " .$msg . ")");
				}
			}
			
						$this->completed = true;
			return 'Export is done! Press Back button';
		}
		
		private function prepareObjects($branches) {
			$this->elements = array();
			foreach($branches as $branch) {
				$this->prepareObject($branch);
			}  
		}
		
		private function prepareObject($branch) { 
			if(!$branch instanceof umiHierarchyElement ) {
				$branch = umiHierarchy::getInstance()->getElement( $branch, false, false );
				
				if(!$branch instanceof umiHierarchyElement ) {
					
				}
			}
			$childs = umiHierarchy::getInstance()->getChilds($branch->getId(), true, true, 1);

			if(sizeof($childs)) 
			{
				foreach ($childs as $child_id => $tmp) {
					$this->prepareObject($child_id);
				}
			}
			
			$type = umiHierarchyTypesCollection::getInstance()->getType( $branch->getTypeId() );
			
			if($type->getExt() == 'object' &&  $type -> getName() == 'catalog') {
				$this->elements[] = $branch;
			}
			
		}
	}
?>