<?php

	class umiDump20Exporter extends umiExporter {
		public function setOutputBuffer() {
			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$buffer->charset("utf-8");
			$buffer->contentType("text/xml");
			return $buffer;
		}

		public function export($branches) {
			if (!count($branches)) {
				$sel = new selector('pages');
				$sel->where('hierarchy')->page(0)->childs(0);
				$branches = $sel->result;
			}

			$temp_dir = "./sys-temp/export/";
			$id = getRequest('param0');
			$file_path = $temp_dir . $id . "." . parent::getFileExt();

			if(getRequest('as_file') === '0') {
				$exporter = new xmlExporter($this->getSourceName());
				$exporter->addBranches($branches);
				$result = $exporter->execute();
				return $result->saveXML();
			}

			if(file_exists($file_path) && !file_exists(CURRENT_WORKING_DIR . '/sys-temp/runtime-cache/' . md5($this->getSourceName()))) unlink($file_path);

			$new_file_path = $file_path . '.tmp';

			$exporter = new xmlExporter($this->getSourceName(), 25);
			$exporter->addBranches($branches);
			$dom = $exporter->execute();

			if(file_exists($file_path)) {
				$reader = new XMLReader;
				$writer = new XMLWriter;

				$reader->open($file_path/*, "utf-8",  LIBXML_COMPACT ^ LIBXML_NOEMPTYTAG*/);
				$writer->openURI($new_file_path);
				$writer->startDocument('1.0', 'utf-8');

				$continue = $reader->read();
				while($continue){
					if ($reader->nodeType == XMLReader::ELEMENT) {
						$node_name = $reader->name;
						if($node_name != 'umidump') {
							$node_value = $reader->readInnerXML();
							$writer->startElement($node_name);
							$writer->writeRaw($node_value);
							if($dom->getElementsByTagName($node_name)->item(0)->hasChildNodes() && $node_name != 'meta') {
								$children = $dom->getElementsByTagName($node_name)->item(0)->childNodes;
								foreach ($children as $child) {

									$newdoc = new DOMDocument;
									$newdoc->formatOutput = true;
									$node = $newdoc->importNode($child, true);
									$newdoc->appendChild($node);
									$writer->writeRaw($newdoc->saveXML($node, LIBXML_NOXMLDECL));
								}
							}

							$writer->fullEndElement();
							$continue = $reader->next();
							continue;

						} else {
							$writer->startElement($node_name);
							$writer->writeAttribute('version', $reader->getAttribute('version'));
							$writer->writeAttribute('xmlns:xlink', 'http://www.w3.org/TR/xlink');
						}
					}
					$continue = $reader->read();
				}

				$reader->close();
				$writer->endDocument();
				unlink($file_path);
				rename($new_file_path, $file_path);
			} else {
				file_put_contents($file_path, $dom->saveXML());
			}

			$this->completed = $exporter->isCompleted();
			return file_get_contents($file_path);
		}
	}
?>