<?php 
	require CURRENT_WORKING_DIR . '/libs/config.php';

	// Patch for Flex files uploader
	if(isset($_SERVER['HTTP_USER_AGENT']) &&
		(strstr($_SERVER['HTTP_USER_AGENT'], 'Shockwave Flash')!== false || strstr($_SERVER['HTTP_USER_AGENT'], 'Adobe Flash Player'))
		&& isset($_GET['PHPSESSID'])) {
		session_id($_GET['PHPSESSID']);
	}
	$config = mainConfiguration::getInstance();
	$buffer = OutputBuffer::current('HTTPOutputBuffer');

	if(PRE_AUTH_ENABLED) {
		umiAuth::tryPreAuth();
	}
		

	//Parse [stub] ini section
	if($config->get('stub', 'enabled')) {
		if(is_array($ips = $config->get('stub', 'filter.ip'))) {
			$enabled = !in_array(getServer('REMOTE_ADDR'), $ips);
		} else {
			$enabled = true;
		}
		if($enabled) {
			$stubFilePath = $config->includeParam('system.stub');
			if(is_file($stubFilePath)) {
				require $stubFilePath;
				exit;
			} else {
				throw new coreException("Stub file \"{$stubFilePath}\" not found");
			}
		}
	}

	if($config->get('kernel', 'matches-enabled')) {
		$matches = new matches("sitemap.xml");
		$matches->setCurrentURI(getRequest('path'));

		try {
			$matches->execute();
		} catch (Exception $e) {
			traceException($e);
		}

		unset($matches);
	}

	if($config->get('cache', 'static.enabled')) {
		require CURRENT_WORKING_DIR . '/libs/cacheControl.php';
		$staticCache = new staticCache;
		$staticCache->load();
	} else $staticCache = null;

	$permissions = permissionsCollection::getInstance();
	$cmsController = cmsController::getInstance();
	$cmsController->analyzePath();

	$currentMode = $cmsController->getCurrentMode();
	$domainId = $cmsController->getCurrentDomain()->getId();
	$langId = $cmsController->getCurrentLang()->getId();

	if($currentMode == 'admin') {
		$templateName = 'main.xsl';
	} else {
		$templateName = system_get_tpl();
	}
	define('XSLT_TPL_MODE', (substr($templateName, -4, 4) == '.xsl'));

	$tplTemplater = templater::getInstance();


	if(XSLT_TPL_MODE) {

		$currentModule = $cmsController->getCurrentModule();
		$currentMethod = $cmsController->getCurrentMethod();

		$userId = $permissions->getUserId();
		$isAllowed = $permissions->isAllowedMethod($userId, $currentModule, $currentMethod);


		$xsltTemplater = xslTemplater::getInstance();
		$xsltTemplater->init();

		if($currentMode != 'admin') { $cmsController->parsedContent = macros_content(); }

		if($currentMode == 'admin') {
			$xsltTemplater = xslAdminTemplater::getInstance();
		}
		$currTemplater = $xsltTemplater;

		if($currentMode == 'admin') {
			$templatePath = $config->includeParam('templates.skins', array('skin' => xslAdminTemplater::getCurrentSkinName()));
		} else {
			$templatePath = $config->includeParam('templates.xsl');
		}

		// Force current module init (to call maybe usefull onInit methods)
		$cmsController->getModule($currentModule);
		if((!$permissions->isAdmin() || !$isAllowed) && file_exists($templatePath . 'main_login.xsl')) {
			if($permissions->isAuth() && $currentMode == 'admin') {

				$sqlWhere = "owner_id = {$userId}";
				$userGroups = umiObjectsCollection::getInstance()->getObject($userId)->getValue('groups');
				foreach ($userGroups as $userGroup) {
					$sqlWhere = $sqlWhere . " or owner_id = {$userGroup}";
				}

				$sql = "SELECT * FROM cms_permissions WHERE " . $sqlWhere . " and (method = '' or method is null)";
				$result = l_mysql_query($sql);

				if (mysql_num_rows($result) !==0) {
					$regedit = regedit::getInstance();
					while ($row = mysql_fetch_array($result)){
						$module = $row[0];
						$method = $regedit->getVal("//modules/{$module}/default_method_admin");
						if ($permissions->isAllowedMethod($userId, $module, $method)) {
							def_module::redirect('http://'.$cmsController->getCurrentDomain()->getHost() . '/admin/'. $module . '/' . $method);
							break;
						}
					}
				}
			}

			$templatePath .= 'main_login.xsl';
		} else {
			$templatePath .= $templateName;
		}
	} else {
		$cmsController->parsedContent = macros_content();

		$currTemplater = $tplTemplater;
		$templatePath = $config->includeParam('templates.tpl') . 'content/' . $templateName;
	}

	if($currentMode == 'admin') {
		$cmsController->parsedContent = macros_content();
	}

	if(XSLT_TPL_MODE) {
			
		$currTemplater->init($templatePath);

		if(getRequest("xmlMode") == "force") {
			$buffer->contentType('text/xml');
			$buffer->push($currTemplater->flushXml());
		} else {
			// if exists
			$cmsController->getModule($currentModule)->cms_callMethod('systemonBeforeDisplay', array());
			
			$buffer->push($currTemplater->parseResult());
		}

		if(is_null(getRequest('showStreamsCalls')) == false) {
			$buffer->contentType('text/xml');
			$buffer->clear();
			$buffer->push(umiBaseStream::getCalledStreams());
			$buffer->end();
		}
	} else { 
		if(!file_exists($templatePath)) {
			$buffer = outputBuffer::current();
			$buffer->contentType('text/html');
			$buffer->clear();
			$buffer->push(file_get_contents(SYS_ERRORS_PATH . 'no_design_template.html'));
			$buffer->end();
		}
		$templateContent = file_get_contents($templatePath);
		$templateContent = str_replace("%pid%", $cmsController->getCurrentElementId(), $templateContent);
		$result = $currTemplater->parseInput($templateContent);
		$result = str_replace("%catched_errors%", macros_catched_errors(), $result);
		$buffer->push($currTemplater->cleanUpResult($result));
	}


	if($statistics = $cmsController->getModule('stat')) {
		$statistics->pushStat();
	}

	if($staticCache instanceof staticCache) {
		$staticCache->save($buffer->content());
	}

	$buffer->end();
?>